package io.zipcoder;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ItemParser {

    private Pattern pattern;
    private Matcher matcher;

    public ArrayList<String> parseRawDataIntoStringArray(String rawData) {
        String stringPattern = "##";
        ArrayList<String> response = splitStringWithRegexPattern(stringPattern, rawData);
        return response;
    }

    public ArrayList<ArrayList<String>> splitIntoPairs(ArrayList<String> list) {
        ArrayList<ArrayList<String>> finalArray = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            ArrayList<String> tempArrayList = new ArrayList<>();
            String[] tempArray = list.get(i).split("[;^!@%]");
            for (int j = 0; j < tempArray.length; j++) {
                tempArrayList.add(tempArray[j]);
            }
            finalArray.add(tempArrayList);
//            tempArrayList.addAll(Arrays.asList(tempArray));
//            finalArray.get(i).addAll(tempArrayList);
        }
        return finalArray;
    }

    public Item parse(ArrayList<String> arrayList) {
        String name; double price; String type; String expiration;
        for (String field : arrayList) {
            if (field.contains("Name")) {
                name = field.substring(field.indexOf(":"));
            } else if (field.contains("Price")) {
                price = field.ss
            }
        }
    }


    public Item parseStringIntoItem(String rawItem) throws ItemParseException {
        return null;
    }

    public ArrayList<String> findKeyValuePairsInRawItemData(String rawItem) {
        String stringPattern = "[;|^]";
        ArrayList<String> response = splitStringWithRegexPattern(stringPattern, rawItem);
        return response;
    }

    public HashMap<String, String> mapKeyValuePairs(String rawItem) {
        ArrayList<String> groceryArrayList = parseRawDataIntoStringArray(rawItem);
        pattern = Pattern.compile(":");
//        matcher = pattern.matcher(rawItem);
        HashMap<String, String> groceryListValues = new HashMap<>();
        for (String item : groceryArrayList) {
            matcher = pattern.matcher(item);
            try {
                groceryListValues.put(matcher.group(), matcher.group());
            } catch (IllegalStateException e) {
                e.printStackTrace();
            }
        }
        return groceryListValues;
    }

    private ArrayList<String> splitStringWithRegexPattern(String stringPattern, String inputString) {
        return new ArrayList<String>(Arrays.asList(inputString.split(stringPattern)));
    }

    public String correctSpelling(String text) {
        SpellingCorrector spellingCorrector = new SpellingCorrector();
        return spellingCorrector.correctAllSpelling(text);
    }

    class SpellingCorrector {

        String correctMilk(String text) {
            pattern = Pattern.compile("Milk", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            return matcher.replaceAll("Milk");
        }

        String correctBread(String text) {
            pattern = Pattern.compile("Bread", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            return matcher.replaceAll("Bread");
        }

        String correctCookies(String text) {
            pattern = Pattern.compile("Cookies|Co0kies", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            return matcher.replaceAll("Cookies");
        }

        String correctApples(String text) {
            pattern = Pattern.compile("Apples", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            return matcher.replaceAll("Apples");
        }

        String correctName(String text) {
            pattern = Pattern.compile("Name", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            return matcher.replaceAll("Name");
        }

        String correctPrice(String text) {
            pattern = Pattern.compile("Price", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            return matcher.replaceAll("Price");
        }

        String correctAllSpelling(String text) {
            String corrected = correctBread(text);
            corrected = correctName(corrected);
            corrected = correctApples(corrected);
            corrected = correctCookies(corrected);
            corrected = correctMilk(corrected);
            corrected = correctPrice(corrected);
            return corrected;
        }
    }

    class OccurenceCounter {

        int countOccurencesOfMilk(String text) {
            int count = 0;
            pattern = Pattern.compile("Milk", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            while (matcher.find()) {
                count++;
            }
            return count;
        }

        int countOccurencesOfBread(String text) {
            int count = 0;
            pattern = Pattern.compile("Bread", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            while (matcher.find()) {
                count++;
            }
            return count;
        }

        int countOccurencesOfApples(String text) {
            int count = 0;
            pattern = Pattern.compile("Apples", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            while (matcher.find()) {
                count++;
            }
            return count;
        }

        int countOccurencesOfCookies(String text) {
            int count = 0;
            pattern = Pattern.compile("Cookies| Co0kies|C00kies|C0okies", Pattern.CASE_INSENSITIVE);
            matcher = pattern.matcher(text);
            while (matcher.find()) {
                count++;
            }
            return count;
        }

        int[] countOccurencesOfAllItemsAlphabeticalOrder(String text) {
            int[] itemArray = new int[4];
            itemArray[0] = countOccurencesOfApples(text);
            itemArray[1] = countOccurencesOfBread(text);
            itemArray[2] = countOccurencesOfCookies(text);
            itemArray[3] = countOccurencesOfMilk(text);
            return itemArray;
        }
    }

}
